--
--	Mystic Realms Community Editions' OS-Time Events
--	Contributed by Ace Lite, Xian
--

-- NOTE: XMAS VANILLA TEXTURE SET IS INCOMPELTE, COMPARE TO CURRENT 2.2 SET, KEEP IT IN MIND.

rawset(_G, "time_events_data", {})

-- WINTER (12-2M)
time_events_data.WINTER_TEXTURES = {

	-- Green Flower Zone


	-- GFZ ROCK
	["GFZROCK"] = "XMAS01",
	["GFZCHEKB"] = "XMAS01A",
	["GFZCHEK1"] = "XMAS01A",
	["GFZCHEK2"] = "XMAS01A",
	["GFZWALL"] = "XMASWALL",
	["GFZWALL2"] = "XMASWALL",
	["GFZVINE1"] = "XMAS03",
	["GFZVINE2"] = "XMAS03",
	["GFZVINE3"] = "XMAS04",
	["GFZROCKB"] = "XMASROCKB",
	["GFZCRACK"] = "XMASCRACK",
	["GFZCRAC1"] = "XMASCRACX",
	["GFZCRAC2"] = "XMASCRACX",
	["GFZINSID"] = "XMAS24",
	["GFZFLR08"] = "XMSFLR04",

	-- GFZ GRASS
	["GFZGRASS"] = "SNOWALL",
	["GFZFLR02"] = "XMSFLR02",
	["GFZFLR10"] = "XMSFLR02",
	["GFZFLR21"] = "XMSFLR02",
	["GFZFLR22"] = "XMSFLR02",

	-- GFZ MISC
	["GFZBLOCK"] = "XMAS19",
	["GFZFLR09"] = "XMAS19",
	["GFZBRIDG"] = "XMAS23",
	["GFZFLR05"] = "XMSFLR05",
	["GFZFLR06"] = "XMSFLR06",
}
time_events_data.WINTER_THINGS = {

	-- Green Flower Zone


	[MT_BUSH] = MT_XMASBUSH,
	[MT_BERRYBUSH] = MT_XMASBERRYBUSH,
	[MT_BLUEBERRYBUSH] = MT_XMASBLUEBERRYBUSH,
	[MT_GFZBERRYTREE] = MT_MFZTREE,
	[MT_GFZFLOWER3] = MT_FHZICE1,
	[MT_GFZTREE] = MT_FHZTREE,

}
time_events_data.WINTER_MUSIC = {

	-- Green Flower Zone

	["GFZ1"] = "CCZ"

}
time_events_data.WINTER_SKY = {

	-- Green Flower Zone

	[1] = 17


}
time_events_data.WINTER_SKYBOX = {

	-- Green Flower Zone

	["Greenflower"] = {remove_skybox = true},


}

-- XMAS (24.12)
time_events_data.XMAS_TEXTURES = {}
time_events_data.XMAS_THINGS =  {

	-- Green Flower Zone

	[MT_GFZFLOWER3] = MT_FHZICE1,
	[MT_GFZFLOWER2] = MT_LAMPPOST2,
	[MT_GFZFLOWER1] = MT_XMASPOLE,
}

-- HALLOWEEN (31.10)
time_events_data.HALLOWEEN_TEXTURES = {

	-- Green Flower Zone


	-- GFZ ROCK
	["GFZROCK"] = "WFZROCK",
	["GFZCHEKB"] = "WFZCHEKB",
	["GFZCHEK1"] = "WFZCHEK1",
	["GFZCHEK2"] = "WFZCHEK2",
	["GFZWALL"] = "WFZWALL",
	["GFZWALL2"] = "WFZWALL2",
	["GFZVINE1"] = "WFZVINE1",
	["GFZVINE2"] = "WFZVINE2",
	["GFZVINE3"] = "WFZVINE3",
	["GFZROCKB"] = "WFZROCKB",
	["GFZCRACK"] = "WFZCRACK",
	["GFZCRAC1"] = "WFZCRAC1",
	["GFZCRAC2"] = "WFZCRAC2",
	["GFZINSID"] = "WFZINSID",
	["GFZFLR01"] = "WFZFLR01",
	["GFZFLR03"] = "WFZFLR03",
	["GFZFLR04"] = "WFZFLR04",
	["GFZFLR07"] = "WFZFLR07",
	["GFZFLR08"] = "WFZFLR08",
	["GFZFLR11"] = "WFZFLR11",
	["GFZFLR12"] = "WFZFLR12",
	["GFZFLR13"] = "WFZFLR13",
	["GFZFLR14"] = "WFZFLR14",
	["GFZFLR15"] = "WFZFLR15",
	["GFZFLR16"] = "WFZFLR16",
	["GFZFLR17"] = "WFZFLR17",
	["GFZFLR18"] = "WFZFLR18",
	["GFZFLR19"] = "WFZFLR19",
	["GFZFLR20"] = "WFZFLR20",

	-- GFZ GRASS
	["GFZGRASS"] = "WFZGRASS",
	["GFZFLR02"] = "WFZFLR02",
	["GFZFLR10"] = "WFZFLR10",
	["GFZFLR21"] = "WFZFLR21",
	["GFZFLR22"] = "WFZFLR10",

	-- GFZ MISC
	["GFZBLOCK"] = "WFZBLOCK",
	["GFZFLR09"] = "WFZFLR09",
	["GFZBRIDG"] = "WFZBRIDG",
	["GFZBRID2"] = "WFZBRID2",
	["GFZFLR05"] = "WFZFLR05",
	["GFZFLR06"] = "WFZFLR06",
	["GFZFENC2"] = "WFZFENC2",
	["GFZFENCW"] = "WFZFENCW",
	["GFZBLOKS"] = "WFZBLOKS",
	["GFZGRSW"] = "WFZGRSW",
	["GFZROOF"] = "WFZROOF",
	["GFZTILA1"] = "WFZTILA1",
	["GFZTILA2"] = "WFZTILA2",
	["GFZTILB1"] = "WFZTILB1",
	["GFZTILB2"] = "WFZTILB2",
	["GFZTILC1"] = "WFZTILC1",
	["GFZTILC2"] = "WFZTILC2",
	["GFZTILD1"] = "WFZTILD1",
	["GFZTILD2"] = "WFZTILD2",
	["GFZTILE1"] = "WFZTILE1",
	["GFZTILE2"] = "WFZTILE2",
	["GFZTILF1"] = "WFZTILF1",
	["GFZTILF2"] = "WFZTILF2",
	["GFZTILG1"] = "WFZTILG1",
	["GFZTILG2"] = "WFZTILG2",
	["GFZTIL01"] = "WFZTIL01",
	["GFZTIL02"] = "WFZTIL02",
	["GFZTIL03"] = "WFZTIL03",
	["GFZTIL04"] = "WFZTIL04",
	["GFZTIL05"] = "WFZTIL05",
	["GFZTIL06"] = "WFZTIL06",
	["GFZTIL07"] = "WFZTIL07",
	["GFZTIL08"] = "WFZTIL08",
	["GFZTIL09"] = "WFZTIL09",
	["GFZTIL10"] = "WFZTIL10",
	["GFZTIL11"] = "WFZTIL11",
	["GFZWAVE"] = "WFZWAVE",
	["GFZRAIL"] = "WFZRAIL",
	["GFZRAIL2"] = "WFZRAIL2",
	["GFVINESO"] = "WFVINESO",
	["GFVINES"] = "WFVINES",
	["GFZFNCC"] = "WFZFNCC",
	["GFZFNCCG"] = "WFZFNCCG",
	["GFZFNCB"] = "WFZFNCB",
	["GFSM1"] = "WFZSM1",
	["GFSM2"] = "WFZSM2",
	["GFSM3"] = "WFZSM3",
	["GFSM4"] = "WFZSM4",

}
time_events_data.HALLOWEEN_THINGS = {}
time_events_data.HALLOWEEN_MUSIC = {}
time_events_data.HALLOWEEN_SKY = {}
time_events_data.HALLOWEEN_SKYBOX = {}